import 'package:renderable/renderable.dart';

void main() {
  var library = LibraryElement(
    topLevelElements: [
      ClassElement(
        name: 'RenderableValue',
        fields: [
          FieldElement(
            name: 'nullValue',
            type: DartType.VAR,
            value: NullValue(),
          ),
          FieldElement(
            name: 'intValue',
            type: DartType.INT,
            value: IntValue(123),
          ),
          FieldElement(
            name: 'doubleValue',
            type: DartType.DOUBLE,
            value: DoubleValue(1.23),
          ),
          FieldElement(
            name: 'numValue',
            type: DartType.NUM,
            value: NumValue(1233),
          ),
          FieldElement(
            name: 'boolValue',
            type: DartType.BOOL,
            value: BoolValue.True,
          ),
          FieldElement(
            name: 'listValue',
            type: DartType.LIST,
            value: ListValue([
              IntValue(1),
              IntValue(2),
              IntValue(3),
            ]),
          ),
          FieldElement(
            name: 'listValue2',
            type: DartType.LIST,
            value: ListValue([
              StringValue('1'),
              StringValue('2'),
              StringValue('3'),
            ]),
          ),
          FieldElement(
            name: 'mapValue',
            type: DartType.MAP,
            value: MapValue({
              StringValue('key'): DoubleValue(1.3),
            }),
          ),
        ],
      ),
    ],
  );

  FileUtils.writeLibraryToFile(
    library,
    'example/generated/renderable_value_example.generated.dart',
  );
}
