import 'package:meta/meta.dart';
import 'package:renderable/src/contract/renderable.dart';
import 'package:renderable/src/util/template_utils.dart';

class DartType extends Renderable {
  String name;
  String prefix;

  DartType({
    @required this.name,
    this.prefix,
  });

  @override
  String render() {
    return TemplateUtils.stringFromList([
      if (this.prefix != null) "${this.prefix}.",
      this.name,
    ], delimiter: " ");
  }

  static final DartType EMPTY = DartType(name: '');
  static final DartType VOID = DartType(name: 'void');
  static final DartType DYNAMIC = DartType(name: 'dynamic');
  static final DartType VAR = DartType(name: 'var');
  static final DartType INT = DartType(name: 'int');
  static final DartType DOUBLE = DartType(name: 'double');
  static final DartType NUM = DartType(name: 'num');
  static final DartType BOOL = DartType(name: 'bool');
  static final DartType STRING = DartType(name: 'String');
  static final DartType OBJECT = DartType(name: 'Object');
  static final DartType LIST = DartType(name: 'List');
  static final DartType MAP = DartType(name: 'Map');
  static final DartType NULL = DartType(name: 'null');
}
